import * as React from 'react';
import { StyleData } from './utils/types';
import './index.less';
interface StyleSetterProps {
    value: StyleData;
    defaultValue: string;
    placeholder: string;
    field: any;
    onChange: (val: any) => void;
    isShowCssCode: boolean;
    showModuleList: string[];
}
export default class StyleSetterV2 extends React.PureComponent<StyleSetterProps> {
    static defaultProps: {
        unit: string;
        placeholderScale: number;
        showModuleList: string[];
        isShowCssCode: boolean;
        layoutPropsConfig: {
            showDisPlayList: string[];
            isShowPadding: boolean;
            isShowMargin: boolean;
            isShowWidthHeight: boolean;
        };
        fontPropsConfig: {
            fontFamilyList: {
                value: string;
                label: string;
            }[];
        };
        positionPropsConfig: {
            isShowFloat: boolean;
            isShowClear: boolean;
        };
    };
    state: {
        styleData: {};
        cssCodeVisiable: boolean;
        initFlag: boolean;
    };
    componentDidMount(): void;
    changeCssCodeVisiable: (visible: boolean) => void;
    /**
     * style更改
     * @param styleKey
     * @param value
     */
    onStyleChange: (styleDataList: StyleData[]) => void;
    onStyleDataChange: (styleData: StyleData) => void;
    render(): JSX.Element;
}
export {};
